// CENGINEDEF.H

#if !defined ( _CENGINEDEF_H_ )

#define _CENGINEDEF_H_

#define ENGINE_ANALYSIS						0
#define ENGINE_AUTHOR						1
#define ENGINE_CAPABILITIES					2
#define ENGINE_DEBUG						3
#define ENGINE_ENGINEMODE					4
#define ENGINE_ENGINEOK						5
#define ENGINE_ERROR						6
#define ENGINE_FORWARD						7
#define ENGINE_GAME							8
#define	ENGINE_GO							9
#define ENGINE_HALT							10
#define ENGINE_ID							11
#define ENGINE_JUMPTO						12
#define ENGINE_LEVELS_BLITZGAME				13
#define ENGINE_LEVELS_LONGGAME				14
#define ENGINE_LEVELS_FIXEDDEPTH			15
#define ENGINE_LEVELS_FIXEDTIME				16
#define ENGINE_LEVELS_INFINITEANALYSIS		17
#define ENGINE_MOVE							18
#define ENGINE_NAME							19
#define ENGINE_NEW							20
#define ENGINE_OFFERDRAW					21
#define ENGINE_OPPONENTS					22
#define ENGINE_OPTION						23
#define ENGINE_PING							24
#define ENGINE_PONG							25
#define ENGINE_POSITION						26
#define ENGINE_REQUESTGAME					27
#define ENGINE_REQUESTPOSITION				28
#define ENGINE_SEARCHINFO					29
#define ENGINE_SETCOMMENT					30
#define ENGINE_SETOPTION					31
#define ENGINE_SHOWWINDOW					32
#define ENGINE_STATUS						33
#define ENGINE_QUIT							34

#define ENGINE_CONSOLE						-1
#define ENGINE_CONSOLE_INFO					-2

#define BOARD_DISPLAY						1

// !-Commands
#define ENGINE_ASX_DB64						2000

// ?-Commands
#define ENGINE_QMRK_DISPLAYBOARD			3000
#define ENGINE_QMRK_BOOKUPDATE				3001

// #-Commands
#define ENGINE_NMBRSGN_MOVEGENERATE			4000
#define ENGINE_NMBRSGN_PERFT				4001
#define ENGINE_NMBRSGN_TIME					4002

// $-Commands
#define ENGINE_$CLEARCOUNT					5001
#define ENGINE_$CLEAROUTPUT					5002
#define ENGINE_$DEBUG						5003
#define ENGINE_$DXP							5004
#define ENGINE_$ENGINEREADY					5005
#define ENGINE_$EVAL						5006
#define ENGINE_$POLL						5007
#define ENGINE_$STATUS						5008
#define ENGINE_$INFO						5009
#define ENGINE_$GAME						5010
#define ENGINE_$LOG							5011
#define ENGINE_$MATCH						5012
#define ENGINE_$PRM							5013
#define ENGINE_$PDN							5014

#define ENGINE_$PPMODE						5100
#define ENGINE_$PPPROC						5101

// @-Commands ( @ = AT )
#define ENGINE_AT_HALT						6000
#define ENGINE_AT_OPEN						6001
#define ENGINE_AT_LIST						6002
#define ENGINE_AT_PAUSE						6003
#define ENGINE_AT_RUN						6004
#define ENGINE_AT_STOP						6005

// SearchThread
#define ENGINE_SEARCHTHREAD_SEARCHINFO		7000

// EngineInfo
#define ENGINE_ENGINEINFO_INIT				8000
#define ENGINE_ENGINEINFO_DXP				8001
#define ENGINE_ENGINEINFO_PRM				8002

// DXP
#define ENGINE_DXP_GAMEREQ					1
#define ENGINE_DXP_GAMEACC					2
#define ENGINE_DXP_MOVE						3
#define ENGINE_DXP_GAMEEND					4
#define ENGINE_DXP_CHAT						5
#define ENGINE_DXP_BACKREQ					6
#define ENGINE_DXP_BACKACC					7

#define ENGINE_DXPGAMEREQ_MESSAGE			9996
#define ENGINE_DXPMOVE_MESSAGE				9997
#define ENGINE_DXPSTAT_MESSAGE				9998
#define ENGINE_DXP_MESSAGE					9999
#define ENGINE_DXP_STR_GAMEREQ				"R"
#define ENGINE_DXP_STR_GAMEACC				"ADamage 12.1                     0"
#define ENGINE_DXP_STR_GAMEEND				"E00"
#define ENGINE_DXP_STR_GAMEEND_LOOSE		"E10"
#define ENGINE_DXP_STR_GAMEEND_DRAW			"E20"
#define ENGINE_DXP_STR_GAMEEND_WIN			"E30"

#define DXP_MATCH_GAME_START				0
#define DXP_MATCH_GAME_MOVE					1
#define DXP_MATCH_GAME_END					2

#define DXP_MATCH_LOG_OPEN					0
#define DXP_MATCH_LOG_GAME_START			1
#define DXP_MATCH_LOG_GAME_BOARD			2
#define DXP_MATCH_LOG_GAME_MOVE				3
#define DXP_MATCH_LOG_GAME_END				4
#define DXP_MATCH_LOG_STAT					5

#define ENGINE_NOTIFICATION_ONUPDATE_ENGINEMODE			-10
#define ENGINE_NOTIFICATION_ONUPDATE_ENGINEWINDOWTEXT	-11

// Engine NMBRSGN BTableGenerate Options
#define ENGINE_NMBRSGN_BTABLEGENERATE_TABLE		0
#define ENGINE_NMBRSGN_BTABLEGENERATE_NBB		1

// DRL Options
#define DLR_INFO_PVPOSITION					0
#define DLR_STAT_HASH						0

#define DLR_MATCH_ALTERNATE					0
#define DLR_MATCH_BOOK						1
#define DLR_MATCH_GAMES						2
#define DLR_MATCH_GO						3
#define DLR_MATCH_LOG						4
#define DLR_MATCH_MAXMOVES					5
#define DLR_MATCH_NAME						6

#define DLR_PDN_OPEN						0
#define DLR_PDN_READ						1
#define DLR_PDN_INFO						2
#define DLR_PDN_HEADER						3

#define DLR_EVAL_NO_OUTPUT					0
#define DLR_EVAL_OUTPUT						1
#define DLR_EVAL_TEST						2

#define DLR_DEBUG_OFF						0
#define DLR_DEBUG_ON						1
#define DLR_DEBUG_POSITION					2
#define DLR_DEBUG_DISPLAY					4

#define PRM_SEARCH_MCP_DEPTHREDUCTIONFACTOR	0
#define PRM_SEARCH_MCP_CHILD_SEARCH			1
#define PRM_SEARCH_PP_OUTPUT				2
#define PRM_SEARCH_PVSPLIT_SPLIDEPTH		3
#define PRM_SEARCH_SUBSEARCHMODE			4
#define PRM_SEARCH_STARTSEARCHDEPTH			5
#define PRM_SEARCH_QSEARCH					6
#define PRM_SEARCH_FHR						7
#define PRM_SEARCH_SNGEX					8
#define PRM_SEARCH_COUNTCLEAR				9
#define PRM_SEARCH_LOGGING					10
#define PRM_SEARCH_HASHWRITE				11
#define PRM_SEARCH_MINMAX					12
#define PRM_SEARCH_EVALHASHWRITE			13
#define PRM_SEARCH_PVSPLIT_SPLITBRANCH		14
#define PRM_SEARCH_HISTORY					15
#define PRM_SEARCH_MOVEGEN_MODE				16
#define PRM_SEARCH_ENGINE					17
#define PRM_SEARCH_SP_OUTPUT				18
#define PRM_SEARCH_DEBUG_OUTPUT				19
#define PRM_SEARCH_SINGULAREXTENSIONDEPTH	20
#define PRM_SEARCH_HASHREADETC				21
#define PRM_SEARCH_MCP						22
#define PRM_SEARCH_SELECTIVESEARCH			23
#define PRM_SEARCH_LMR						24
#define PRM_SEARCH_IID						25

#define ENGINE_USER_COMMAND					-1
#define ENGINE_ILLEGAL_COMMAND				-2
#define ENGINE_MESSAGE_BUFFER_FULL			-3
				
#define ENGINE_STR_ANALYSIS					"analysis"
#define ENGINE_STR_AUTHOR					"author"
#define ENGINE_STR_OPPONENTS				"opponents"
#define	ENGINE_STR_GO						"go"
#define ENGINE_STR_ENGINEMODE				"enginemode"
#define ENGINE_STR_ENGINEOK					"engineok"
#define ENGINE_STR_ERROR					"error"
#define ENGINE_STR_FORWARD					"forward"
#define ENGINE_STR_GAME						"game"
#define ENGINE_STR_HALT						"halt"
#define ENGINE_STR_ID						"id"
#define ENGINE_STR_JUMPTO					"jumpto"
#define ENGINE_STR_LEVELS_BLITZGAME			"levelsblitzgame"
#define ENGINE_STR_LEVELS_LONGGAME			"levelslonggame"
#define ENGINE_STR_LEVELS_FIXEDDEPTH		"levelsfixeddepth"
#define ENGINE_STR_LEVELS_FIXEDTIME			"levelsfixedtime"
#define ENGINE_STR_LEVELS_INFINITEANALYSIS	"levelsinfiniteanalysis"
#define ENGINE_STR_MOVE						"move"
#define ENGINE_STR_NAME						"name"
#define ENGINE_STR_NEW						"new"
#define ENGINE_STR_OFFERDRAW				"offerdraw"
#define ENGINE_STR_OPTION					"option"
#define ENGINE_STR_PING						"ping"
#define ENGINE_STR_PONG						"pong"
#define ENGINE_STR_POSITION					"position"
#define ENGINE_STR_REQUESTGAME				"requestgame"
#define ENGINE_STR_REQUESTPOSITION			"requestposition"
#define ENGINE_STR_SEARCHINFO				"searchinfo"
#define ENGINE_STR_SETCOMMENT				"setcomment"
#define ENGINE_STR_SETOPTION				"setoption"
#define ENGINE_STR_SHOWWINDOW				"showwindow"
#define ENGINE_STR_STATUS					"status"
#define ENGINE_STR_QUIT						"quit"

#define ENGINE_STR_$CLEARCOUNT				"$clearcount"
#define ENGINE_STR_$CLEAROUTPUT				"$clearoutput"
#define ENGINE_STR_$DEBUG					"$debug"
#define ENGINE_STR_$DXP						"$dxp"
#define ENGINE_STR_$ENGINEREADY				"$engineready"
#define ENGINE_STR_$EVAL					"$eval"
#define ENGINE_STR_$POLL					"$poll"
#define ENGINE_STR_$STATUS					"$status"
#define ENGINE_STR_$INFO					"$info"
#define ENGINE_STR_$GAME					"$game"
#define ENGINE_STR_$LOG						"$log"
#define ENGINE_STR_$MATCH					"$match"
#define ENGINE_STR_$STAT					"$stat"
#define ENGINE_STR_$PRM						"$prm"
#define ENGINE_STR_$PDN						"$pdn"
	
#define ENGINE_STR_$PPMODE					"$ppmode"
#define ENGINE_STR_$PPPROC					"$ppproc"
#define ENGINE_STR_$PPTEST					"$pptest"

#define ENGINE_STR_AT_HALT					"@halt"
#define ENGINE_STR_AT_OPEN					"@open"
#define ENGINE_STR_AT_LIST					"@list"
#define ENGINE_STR_AT_PAUSE					"@pause"
#define ENGINE_STR_AT_RUN					"@run"
#define ENGINE_STR_AT_STOP					"@stop"

#define ENGINE_STR_NMBRSGN_MOVEGENERATE		"#movegenerate"
#define ENGINE_STR_NMBRSGN_PERFT			"#perft"
#define ENGINE_STR_NMBRSGN_TIME				"#time"

#define ENGINE_STR_ASX_DB64					"!db64"

#define ENGINE_STR_QMRK_DISPLAYBOARD		"?displayboard"
#define ENGINE_STR_QMRK_BOOKUPDATE			"?bookupdate"

#define DLR_MATCH_STR_ALTERNATE				"alternate"
#define DLR_MATCH_STR_BOOK					"book"
#define DLR_MATCH_STR_GAMES					"games"
#define DLR_MATCH_STR_GO					"go"
#define DLR_MATCH_STR_LOG					"log"
#define DLR_MATCH_STR_MAXMOVES				"maxmoves"
#define DLR_MATCH_STR_NAME					"name"

#define DLR_DXP_STR_SERVER					"server"
#define DLR_DXP_STR_CLIENT					"client"
#define DLR_DXP_STR_BALLOT					"ballot"
#define DLR_DXP_STR_GAME					"game"
#define DLR_DXP_STR_MATCH					"match"
#define DLR_DXP_STR_GO						"go"
#define DLR_DXP_STR_INFO					"nfo"
#define DLR_DXP_STR_STAT					"stat"
#define DLR_DXP_STR_PRM						"prm"
#define DLR_DXP_STR_PRM_MAXTIME				"t"
#define DLR_DXP_STR_PRM_MAXMOVES			"m"

#define DLR_PDN_STR_OPEN					"open"
#define DLR_PDN_STR_READ					"read"
#define DLR_PDN_STR_INFO					"info"
#define DLR_PDN_STR_HEADER					"header"

#define ENGINE_STR_ENGINEINFO_INIT			"init"

#define ENGINE_STR_TURN_WHITE				"white"
#define ENGINE_STR_TURN_BLACK				"black"
#define ENGINE_STR_TURN_ADD					"add"

#define ENGINE_STR_WHITEMAN					"wm"
#define ENGINE_STR_WHITEKING				"wk"
#define ENGINE_STR_BLACKMAN					"bm"
#define ENGINE_STR_BLACKKING				"bk"
#define ENGINE_STR_EMPTY					"em"

#define ENGINE_STR_CHAR_WHITEMAN			'w'
#define ENGINE_STR_CHAR_WHITEKING			'W'
#define ENGINE_STR_CHAR_BLACKMAN			'b'
#define ENGINE_STR_CHAR_BLACKKING			'B'
#define ENGINE_STR_CHAR_EMPTY				'e'

#define ENGINE_STR_CHAR_GAMEMOVE			'm'

#define ENGINE_STR_OPPONENTMODE_PLAYER_PLAYER	"player-player"
#define ENGINE_STR_OPPONENTMODE_PLAYER_ENGINE	"player-engine"
#define ENGINE_STR_OPPONENTMODE_ENGINE_PLAYER	"engine-player"
#define ENGINE_STR_OPPONENTMODE_ENGINE_ENGINE	"engine-engine"

#define ENGINE_STR_SEARCHINFO_SEARCH		"search"
#define ENGINE_STR_SEARCHINFO_PV			"pv"
#define ENGINE_STR_SEARCHINFO_STRING		"string"

#define ENGINE_STR_BLITZGAME_TIME			"time"

#define ENGINE_STR_SEARCHTHREAD_SEARCHINFO	"searchthread"
#define	ENGINE_MAXOPTIONS					32
#define ENGINE_MAXLIST						32
#define ENGINE_BUTTON						0
#define ENGINE_CHECKMARK					1
#define ENGINE_SPIN							2
#define ENGINE_COMBO						3

// Option Strings
#define ENGINE_STR_OPTIONS_MIN				"min"
#define ENGINE_STR_OPTIONS_MAX				"max"
#define ENGINE_STR_OPTIONS_DEFAULT			"default"
#define ENGINE_STR_OPTIONS_VAR				"var"
#define ENGINE_STR_OPTIONS_TYPE				"type"
#define ENGINE_STR_OPTIONS_DIALOGXY			"dialogxy"

#define ENGINE_MODE_NORMAL					0
#define ENGINE_MODE_ANALYSIS				1
#define ENGINE_MODE_GAME					2
#define ENGINE_MODE_MATCH					3
#define ENGINE_MODE_LEARN					4
#define ENGINE_MODE_BOOK_UPDATE				5
#define ENGINE_MODE_GEN_ENDGAMEDATABASE		6
#define ENGINE_MODE_INFINITE_ANALYSIS		7

#define ENGINE_MODEMASK_POSITION			0x1
#define ENGINE_MODEMASK_GAME				0x2
#define ENGINE_MODEMASK_MATCH				0x4
#define ENGINE_MODEMASK_ANALYSIS			0x8
#define ENGINE_MODEMASK_LEARN				0x10
#define ENGINE_MODEMASK_BOOK_UPDATE			0x20
#define ENGINE_MODEMASK_GEN_ENDGAMEDATABASE	0x40
#define ENGINE_MODEMASK_MOVE				0x80
#define ENGINE_MODEMASK_OUTPUT_EVAL			0x100
#define ENGINE_MODEMASK_INFINITE_ANALYSIS	0x200

#define ENGINE_STR_MODE_ENGINE				"guide"
#define ENGINE_STR_MODE_DEBUG				"debug"

#define ENGINE_OPPONENTMODE_PLAYER_PLAYER	0
#define ENGINE_OPPONENTMODE_PLAYER_ENGINE	1
#define ENGINE_OPPONENTMODE_ENGINE_PLAYER	2
#define ENGINE_OPPONENTMODE_ENGINE_ENGINE	3

#define ENGINE_SEARCH_BLITZGAME				0
#define ENGINE_SEARCH_NORMALGAME			0
#define ENGINE_SEARCH_LONGGAME				1
#define ENGINE_SEARCH_FIXED_DEPTH			2
#define ENGINE_SEARCH_FIXED_TIME			3
#define ENGINE_SEARCH_MAXDEPTH				32

#define ENGINE_STATUS_INIT					1
#define ENGINE_STATUS_OK					2
#define ENGINE_STATUS_THINK					3
#define ENGINE_STATUS_SEARCH				4
#define ENGINE_STATUS_ERROR					5
#define ENGINE_STATUS_TIME_INTERVAL			500

#define ENGINE_INFINITE_TIME				999999	// = 11.5 Days	
#define ENGINE_INFINITEANALYSIS_TIME		999999	// = 11.5 Days					

#define ENGINE_WHITEMAN						1
#define ENGINE_WHITEKING					2
#define ENGINE_BLACKMAN						-1
#define ENGINE_BLACKKING					-2
#define ENGINE_EMPTY						0

#define WHITEMAN							1
#define WHITEKING							2
#define BLACKMAN							-1
#define BLACKKING							-2
#define EMPTY								0
#define ILLEGAL								3

#define ENGINE_MAX_MESSAGE					16
#define ENGINE_MAX_MESSAGE_LENGTH			256
#define ENGINE_MAX_GAME_MOVES				1024

#define BLITZGAME_NPARAMETERS				5

#define ENGINE_COMMUNICATIONMODE_NONE		0
#define ENGINE_COMMUNICATIONMODE_GUIDE		1
#define ENGINE_COMMUNICATIONMODE_DXP		2

typedef struct {
	bool	bDisplayUpdate ;
	int		iMessageID ;
	CString	csMessageBody ;
} ENGINEMESSAGE ;

#endif	// _CENGINEDEF_H_